public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Justin Lecher" <jlec@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] proj/sci:master commit in: sci-mathematics/petsc/
Date: Thu, 31 Dec 2015 08:48:43 +0000 (UTC)	[thread overview]
Message-ID: <1451548941.ea635c5ba9ce7015a7f3cf0f1aa1b8341e9c0eab.jlec@gentoo> (raw)

commit:     ea635c5ba9ce7015a7f3cf0f1aa1b8341e9c0eab
Author:     Matthias Maier <tamiko <AT> gentoo <DOT> org>
AuthorDate: Thu Dec 31 08:02:03 2015 +0000
Commit:     Justin Lecher <jlec <AT> gentoo <DOT> org>
CommitDate: Thu Dec 31 08:02:21 2015 +0000
URL:        https://gitweb.gentoo.org/proj/sci.git/commit/?id=ea635c5b

sci-mathematics/petsc: version bump to 2.6.3

Package-Manager: portage-2.2.26

 sci-mathematics/petsc/ChangeLog          |   5 +
 sci-mathematics/petsc/petsc-3.6.3.ebuild | 253 +++++++++++++++++++++++++++++++
 2 files changed, 258 insertions(+)

diff --git a/sci-mathematics/petsc/ChangeLog b/sci-mathematics/petsc/ChangeLog
index 861d62b..89fdf76 100644
--- a/sci-mathematics/petsc/ChangeLog
+++ b/sci-mathematics/petsc/ChangeLog
@@ -2,6 +2,11 @@
 # Copyright 1999-2015 Gentoo Foundation; Distributed under the GPL v2
 # $Id$
 
+*petsc-3.6.3 (31 Dec 2015)
+
+  31 Dec 2015; Matthias Maier <tamiko@gentoo.org> +petsc-3.6.3.ebuild:
+  sci-mathematics/petsc: version bump
+
   01 Sep 2015; Marius Brehler <marbre@linux.sungazer.de> petsc-3.5.3.ebuild,
   petsc-3.6.0.ebuild:
   sci-mathematics/petsc: Add subslot for fftw dependency

diff --git a/sci-mathematics/petsc/petsc-3.6.3.ebuild b/sci-mathematics/petsc/petsc-3.6.3.ebuild
new file mode 100644
index 0000000..dd3aed2
--- /dev/null
+++ b/sci-mathematics/petsc/petsc-3.6.3.ebuild
@@ -0,0 +1,253 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+PYTHON_COMPAT=( python2_7 )
+
+inherit eutils flag-o-matic fortran-2 python-any-r1 toolchain-funcs versionator
+
+MY_P="${PN}-$(replace_version_separator _ -)"
+
+DESCRIPTION="Portable, Extensible Toolkit for Scientific Computation"
+HOMEPAGE="http://www.mcs.anl.gov/petsc/"
+SRC_URI="http://ftp.mcs.anl.gov/pub/petsc/release-snapshots/${MY_P}.tar.gz"
+
+LICENSE="petsc"
+SLOT="0"
+KEYWORDS="~x86 ~amd64"
+IUSE="afterimage boost complex-scalars cxx debug doc fftw
+	fortran hdf5 hypre mpi mumps scotch sparse superlu threads X"
+# Failed: imagemagick metis
+
+# hypre and superlu curretly exclude each other due to missing linking to hypre
+# if both are enabled
+REQUIRED_USE="
+	afterimage? ( X )
+	hdf5? ( mpi )
+	hypre? ( cxx mpi )
+	mumps? ( mpi scotch )
+	scotch? ( mpi )
+	^^ ( hypre superlu )
+"
+#	imagemagick? ( X )
+
+RDEPEND="
+	virtual/blas
+	virtual/lapack
+	afterimage? ( media-libs/libafterimage )
+	boost? ( dev-libs/boost )
+	fftw? ( sci-libs/fftw:3.0[mpi?] )
+	hdf5? ( sci-libs/hdf5[mpi?] )
+	hypre? ( >=sci-libs/hypre-2.8.0b[mpi?] )
+	mpi? ( virtual/mpi[cxx?,fortran?] )
+	mumps? ( sci-libs/mumps[mpi?] sci-libs/scalapack )
+	scotch? ( sci-libs/scotch[mpi?] )
+	sparse? ( sci-libs/suitesparse >=sci-libs/cholmod-1.7.0 )
+	superlu? ( sci-libs/superlu )
+	X? ( x11-libs/libX11 )
+"
+#	metis? ( sci-libs/parmetis )
+#	imagemagick? ( media-gfx/imagemagick )
+
+DEPEND="${RDEPEND}
+	${PYTHON_DEPS}
+	virtual/pkgconfig
+	dev-util/cmake
+"
+# cmake is used for parallel building
+# in some configuration setups, legacy build is used (slow)
+
+#
+# PETSc does not want its Makefiles to be invoked with anything higher than
+# -j1. The underlying build system does automatically invoke a parallel
+# build. This might not be what you want, but *hey* not your choice.
+#
+MAKEOPTS="${MAKEOPTS} -j1"
+
+S="${WORKDIR}/${MY_P}"
+
+src_prepare() {
+	epatch \
+		"${FILESDIR}"/${PN}-3.6.0-disable-rpath.patch \
+		"${FILESDIR}"/${PN}-3.6.0-fix_sandbox_violation.patch
+
+	sed -i -e 's%/usr/bin/env python%/usr/bin/env python2%' configure || die
+}
+
+src_configure() {
+	# bug 548498
+	# PETSc runs mpi processes during configure that result in a sandbox
+	# violation by trying to open /proc/mtrr rw. This is not easy to
+	# mitigate because it happens in libpciaccess.so called by libhwloc.so,
+	# which is used by libmpi.so.
+	addpredict /proc/mtrr
+
+	# petsc uses --with-blah=1 and --with-blah=0 to en/disable options
+	petsc_enable() {
+		use "$1" && echo "--with-${2:-$1}=1" || echo "--with-${2:-$1}=0"
+	}
+	# add external library:
+	# petsc_with use_flag libname libdir
+	# petsc_with use_flag libname include linking_libs
+	petsc_with() {
+		local myuse p=${2:-${1}}
+		if use ${1}; then
+			myuse="--with-${p}=1"
+			if [[ $# -ge 4 ]]; then
+				myuse="${myuse} --with-${p}-include=${EPREFIX}${3}"
+				shift 3
+				myuse="${myuse} --with-${p}-lib=$@"
+			else
+				myuse="${myuse} --with-${p}-dir=${EPREFIX}${3:-/usr}"
+			fi
+		else
+			myuse="--with-${p}=0"
+		fi
+		echo ${myuse}
+	}
+
+	# select between configure options depending on use flag
+	petsc_select() {
+		use "$1" && echo "--with-$2=$3" || echo "--with-$2=$4"
+	}
+
+	local mylang
+	local myopt
+
+	use cxx && mylang="cxx" || mylang="c"
+	use debug && myopt="debug" || myopt="opt"
+
+	# environmental variables expected by petsc during build
+	export PETSC_DIR="${S}"
+	export PETSC_ARCH="linux-gnu-${mylang}-${myopt}"
+
+	if use debug; then
+		strip-flags
+		filter-flags -O*
+	fi
+
+	# C Support on Cxx builds is enabled if possible
+	# i.e. when not using complex scalars
+	# (no complex type for both available at the same time)
+
+	# run petsc configure script
+	econf \
+		scrollOutput=1 \
+		CFLAGS="${CFLAGS}" \
+		CXXFLAGS="${CXXFLAGS}" \
+		LDFLAGS="${LDFLAGS}" \
+		--with-shared-libraries \
+		--with-single-library \
+		--with-clanguage=${mylang} \
+		$(use cxx && ! use complex-scalars && echo "with-c-support=1") \
+		--with-petsc-arch=${PETSC_ARCH} \
+		--with-precision=double \
+		--with-gnu-compilers \
+		--with-blas-lapack-lib="$($(tc-getPKG_CONFIG) --libs lapack)" \
+		$(petsc_enable debug debugging) \
+		$(petsc_enable mpi) \
+		$(petsc_select mpi cc mpicc $(tc-getCC)) \
+		$(petsc_select mpi cxx mpicxx $(tc-getCXX)) \
+		$(petsc_enable fortran) \
+		$(use fortran && echo "$(petsc_select mpi fc mpif77 $(tc-getF77))") \
+		$(petsc_enable mpi mpi-compilers) \
+		$(petsc_select complex-scalars scalar-type complex real) \
+		--with-windows-graphics=0 \
+		--with-matlab=0 \
+		--with-cmake=cmake \
+		$(petsc_enable threads pthread) \
+		$(petsc_with afterimage afterimage \
+			/usr/include/libAfterImage -lAfterImage) \
+		$(petsc_with hdf5) \
+		$(petsc_with hypre hypre \
+			/usr/include/hypre -lHYPRE) \
+		$(petsc_with sparse suitesparse) \
+		$(petsc_with superlu superlu \
+			/usr/include/superlu -lsuperlu) \
+		$(petsc_with X x) \
+		$(petsc_with X x11) \
+		$(petsc_with scotch ptscotch \
+			/usr/include/scotch \
+		[-lptesmumps,-lptscotch,-lptscotcherr,-lscotch,-lscotcherr]) \
+		$(petsc_with mumps scalapack \
+			/usr/include/scalapack -lscalapack) \
+		$(petsc_with mumps mumps \
+			/usr/include \
+			[-lcmumps,-ldmumps,-lsmumps,-lzmumps,-lmumps_common,-lpord]) \
+		--with-imagemagick=0 \
+		--with-python=0 \
+		$(petsc_with boost) \
+		$(petsc_with fftw)
+
+# not yet tested:
+#		python bindings, netcdf, fftw
+
+# failed dependencies, perhaps fixed in upstream soon:
+#		$(petsc_with metis parmetis) \ # needs metis too (>=5.0.2)
+#		$(petsc_with imagemagick imagemagick \
+#			/usr/include/ImageMagick $($(tc-getPKG_CONFIG) --libs MagickCore)) \
+#		$(petsc_enable threads pthreadclasses) \
+}
+
+src_install() {
+	# petsc install structure is very different from
+	# installing headers to /usr/include/petsc and lib to /usr/lib
+	# it also installs many unneeded executables and scripts
+	# so manual install is easier than cleanup after "emake install"
+	insinto /usr/include/${PN}
+	doins include/*.h*
+	insinto /usr/include/${PN}/${PETSC_ARCH}/include
+	doins ${PETSC_ARCH}/include/*
+	if use fortran; then
+		insinto /usr/include/${PN}/finclude
+		doins -r include/${PN}/finclude/*
+	fi
+	if ! use mpi ; then
+		insinto /usr/include/${PN}/mpiuni
+		doins include/mpiuni/*.h
+	fi
+	insinto /usr/include/${PN}/conf
+	doins lib/${PN}/conf/{variables,rules,test}
+	insinto /usr/include/${PN}/${PETSC_ARCH}/conf
+	doins ${PETSC_ARCH}/lib/${PN}/conf/{petscrules,petscvariables,RDict.db}
+	insinto /usr/include/${PN}/private
+	doins include/${PN}/private/*.h
+
+	# fix configuration files: replace "${S}" by installed location
+	sed -i \
+		-e "s:"${S}"::g" \
+		"${ED}"/usr/include/${PN}/${PETSC_ARCH}/include/petscconf.h \
+		"${ED}"/usr/include/${PN}/${PETSC_ARCH}/conf/petscvariables || die
+	sed -i \
+		-e "s:-I/include:-I${EPREFIX}/usr/include/${PN}:g" \
+		-e "s:-I/linux-gnu-cxx-opt/include:-I${EPREFIX}/usr/include/${PN}/${PETSC_ARCH}/include/:g" \
+		"${ED}"/usr/include/${PN}/${PETSC_ARCH}/conf/petscvariables || die
+	sed -i \
+		-e "s:usr/lib:usr/$(get_libdir):g" \
+		"${ED}"/usr/include/${PN}/${PETSC_ARCH}/include/petscconf.h || die
+
+	# add information about installation directory and
+	# PETSC_ARCH to environmental variables
+	cat >> 99petsc <<- EOF
+		PETSC_ARCH=${PETSC_ARCH}
+		PETSC_DIR=${EPREFIX}/usr/include/${PN}
+	EOF
+	doenvd 99petsc
+
+	dolib.so ${PETSC_ARCH}/lib/*.so
+	dolib.so ${PETSC_ARCH}/lib/*.so.*
+
+	if use doc ; then
+		einfo "installing documentation (this could take a while)"
+		dodoc docs/manual.pdf
+		dohtml -r docs/*.html docs/changes docs/manualpages
+	fi
+}
+
+pkg_postinst() {
+	elog "The petsc ebuild is still under development."
+	elog "Help us improve the ebuild in:"
+	elog "http://bugs.gentoo.org/show_bug.cgi?id=53386"
+}


             reply	other threads:[~2015-12-31  8:48 UTC|newest]

Thread overview: 59+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2015-12-31  8:48 Justin Lecher [this message]
  -- strict thread matches above, loose matches on Subject: below --
2019-07-12 12:12 [gentoo-commits] proj/sci:master commit in: sci-mathematics/petsc/ Matthias Maier
2019-07-12 11:19 Matthias Maier
2019-07-12 11:19 Matthias Maier
2019-07-12 11:19 Matthias Maier
2019-05-13 15:02 Matthias Maier
2019-03-09  6:07 Matthias Maier
2018-09-17 15:41 Matthias Maier
2018-09-17 15:41 Matthias Maier
2018-09-17 15:41 Matthias Maier
2018-08-31 15:39 Matthias Maier
2018-08-31 15:39 Matthias Maier
2018-05-24  1:21 Matthias Maier
2018-04-23 14:38 Matthias Maier
2018-04-23  1:55 Matthias Maier
2018-03-29 22:16 Matthias Maier
2018-03-19  3:49 Matthias Maier
2018-03-19  3:40 Matthias Maier
2017-10-03 12:58 Andrew Savchenko
2017-10-03 12:58 Andrew Savchenko
2017-01-08 11:03 Marius Brehler
2016-11-24 10:55 Marius Brehler
2016-08-31  6:56 Marius Brehler
2016-08-31  6:56 Marius Brehler
2016-07-12 19:57 Marius Brehler
2016-07-12 19:57 Marius Brehler
2016-07-12 19:57 Marius Brehler
2016-04-23 23:21 Christoph Junghans
2016-04-23 23:21 Christoph Junghans
2015-09-01 10:26 Justin Lecher
2015-06-24  9:51 Justin Lecher
2014-09-16 17:01 Christoph Junghans
2014-09-01 19:47 Jauhien Piatlicki
2014-09-01 13:06 Jauhien Piatlicki
2014-08-10  8:05 Justin Lecher
2014-01-06 18:33 Justin Lecher
2013-02-22 10:15 Justin Lecher
2013-02-10 22:11 Jens-Malte Gottfried
2013-01-07 22:16 Jens-Malte Gottfried
2012-10-05 14:09 Jens-Malte Gottfried
2012-06-09  6:35 Jens-Malte Gottfried
2012-05-23 19:56 Kacper Kowalik
2012-03-23 18:33 Jens-Malte Gottfried
2012-03-06 23:09 Jens-Malte Gottfried
2012-03-06 22:15 Jens-Malte Gottfried
2012-03-05 16:11 Jens-Malte Gottfried
2012-03-04 21:16 Jens-Malte Gottfried
2012-03-04 15:19 Jens-Malte Gottfried
2012-03-04 14:31 Jens-Malte Gottfried
2012-03-03 21:39 Jens-Malte Gottfried
2012-03-03 16:02 Jens-Malte Gottfried
2012-03-03 14:28 Jens-Malte Gottfried
2012-03-03 12:37 Jens-Malte Gottfried
2012-03-03 12:37 Jens-Malte Gottfried
2012-02-28 20:24 Justin Lecher
2012-01-23  6:35 Sebastien Fabbro
2011-06-24 17:09 Justin Lecher
2011-06-21 11:54 Justin Lecher
2011-04-19  6:44 Thomas Kahle

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1451548941.ea635c5ba9ce7015a7f3cf0f1aa1b8341e9c0eab.jlec@gentoo \
    --to=jlec@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox